<?php
/**
* @version		$Id: helper.php 10381 2008-06-01 03:35:53Z pasamio $
* @package		Joomla
* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

class modWhosonlineHelper {

	// show online count
	function getOnlineCount() {
	    $db		  =& JFactory::getDBO();
		$sessions = null;
		// calculate number of guests and members
		$result      = array();

		$query = 'SELECT count(username) '.
					' FROM #__session' .
					' WHERE client_id = 0' .
          ' AND guest = 1' .
          ' AND data not like \'%Googlebot%\'' .
          ' AND data not like \'%msnbot%\'' .
          ' AND data not like \'%Yahoo%\'';
    $db->setQuery($query);
		if ($db->getErrorNum()) {
			JError::raiseWarning( 500, $db->stderr() );
		}

		$result['guest'] = $db->loadResult();

		$query = 'SELECT DISTINCT username' .
				 ' FROM #__session' .
				 ' WHERE client_id = 0' .
				 ' AND guest = 0';

		$db->setQuery($query);
		$members = $db->loadObjectList();
    $result['user'] = count($members);
    $result['members'] = $members;
		if ($db->getErrorNum()) {
			JError::raiseWarning( 500, $db->stderr() );
		}
     
    $query = "select maxonline from my_maxonline";
    $db->setQuery($query);
		$max_online = $db->loadResult();
		if ($result['user'] > $max_online) {
		  #Update db
		  $max_online = $result['user'];
      $query = "update my_maxonline set maxonline=$max_online";
      $db->setQuery($query);
  		$db->query();
    }

		if ($db->getErrorNum()) {
			JError::raiseWarning( 500, $db->stderr() );
		}

		$result['maxonline'] = $max_online;

		return $result;
	}

}
